"use client";
"use client;";
import { useCallback, useEffect } from "react";
var useClickOutside = function useClickOutside2(ref, handler) {
  var memoizedHandler = useCallback(handler, []);
  useEffect(function() {
    var listener = function listener2(event) {
      if (!ref.current || ref.current.contains(event.target)) {
        return;
      }
      memoizedHandler(event);
    };
    document.addEventListener("mousedown", listener);
    document.addEventListener("touchstart", listener);
    return function() {
      document.removeEventListener("mousedown", listener);
      document.removeEventListener("touchstart", listener);
    };
  }, [ref, memoizedHandler]);
};
export {
  useClickOutside as u
};
