"use client";
"use client;";
import React__default from "react";
import { Element } from "../Element/Element.js";
import { Text } from "../Typography/Text.js";
var _excluded = ["children", "size", "shape", "withDelete", "onDelete"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Badge = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var children = _ref.children, _ref$size = _ref.size, size = _ref$size === void 0 ? "medium" : _ref$size, shape = _ref.shape, withDelete = _ref.withDelete, onDelete = _ref.onDelete, props = _objectWithoutProperties(_ref, _excluded);
  var classNames = [];
  if (size) {
    classNames.push("size-".concat(size));
  }
  if (shape) {
    classNames.push("shape-".concat(shape));
  }
  var handleDelete = function handleDelete2(e) {
    e.stopPropagation();
    onDelete === null || onDelete === void 0 || onDelete(e);
  };
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    "data-badge": true,
    ref,
    classNames
  }, props), /* @__PURE__ */ React__default.createElement(Text, null, children), withDelete && /* @__PURE__ */ React__default.createElement(Text, {
    className: "dismiss-button",
    onClick: handleDelete
  }, "×"));
});
export {
  Badge
};
