"use client";
"use client;";
import React__default, { useRef, useState, useCallback, useEffect, createRef, useImperativeHandle } from "react";
import { InputField } from "../InputField/InputField.js";
import { Div } from "../../Element/Tags.js";
function _typeof(o) {
  "@babel/helpers - typeof";
  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof(o);
}
var _excluded = ["numberOfFields", "onChange", "type", "mask", "isOTP", "autoFocus", "pasteFromClipboard", "focusFirstInputOnReset", "isFullWidth"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), true).forEach(function(r2) {
      _defineProperty(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}
function _toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
function validate(value, type) {
  var NUMERIC_REGEX = /^[0-9]+$/;
  var ALPHA_NUMERIC_REGEX = /^[a-zA-Z0-9]+$/i;
  var regex = type === "alphanumeric" ? ALPHA_NUMERIC_REGEX : NUMERIC_REGEX;
  return regex.test(value);
}
var PinInputField = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var length = _ref.numberOfFields, onChange = _ref.onChange, _ref$type = _ref.type, type = _ref$type === void 0 ? "number" : _ref$type, _ref$mask = _ref.mask, mask = _ref$mask === void 0 ? false : _ref$mask, _ref$isOTP = _ref.isOTP, isOTP = _ref$isOTP === void 0 ? false : _ref$isOTP, _ref$autoFocus = _ref.autoFocus, autoFocus = _ref$autoFocus === void 0 ? false : _ref$autoFocus, _ref$pasteFromClipboa = _ref.pasteFromClipboard, pasteFromClipboard = _ref$pasteFromClipboa === void 0 ? "enabled" : _ref$pasteFromClipboa, _ref$focusFirstInputO = _ref.focusFirstInputOnReset, focusFirstInputOnReset = _ref$focusFirstInputO === void 0 ? true : _ref$focusFirstInputO, isFullWidth = _ref.isFullWidth, props = _objectWithoutProperties(_ref, _excluded);
  var pinInputFieldRef = useRef(null);
  var _useState = useState([]), _useState2 = _slicedToArray(_useState, 2), inputRefs = _useState2[0], setInputRefs = _useState2[1];
  var _useState3 = useState([]), _useState4 = _slicedToArray(_useState3, 2), values = _useState4[0], setValues = _useState4[1];
  var _useState5 = useState(true), _useState6 = _slicedToArray(_useState5, 2), moveFocus = _useState6[0], setMoveFocus = _useState6[1];
  var _useState7 = useState(-1), _useState8 = _slicedToArray(_useState7, 2), focusedIndex = _useState8[0], setFocusedIndex = _useState8[1];
  var focus = useCallback(function(index) {
    var _ref$current;
    var ref2 = inputRefs[index];
    ref2 === null || ref2 === void 0 || (_ref$current = ref2.current) === null || _ref$current === void 0 || _ref$current.focus();
  }, [inputRefs]);
  useEffect(function() {
    setInputRefs(function(inputRefs2) {
      var refs = Array(length).fill(0).map(function(_, i) {
        var ref2 = inputRefs2[i] || /* @__PURE__ */ createRef();
        if (autoFocus && i === 0) {
          var _ref$current2;
          (_ref$current2 = ref2.current) === null || _ref$current2 === void 0 || _ref$current2.focus();
        }
        return ref2;
      });
      return refs;
    });
  }, [length, autoFocus]);
  useImperativeHandle(
    ref,
    // @ts-ignore
    function() {
      return _objectSpread(_objectSpread({}, pinInputFieldRef.current), {}, {
        reset: function reset() {
          handleResetPinInput();
        }
      });
    },
    [inputRefs]
  );
  var focusNext = useCallback(function(index) {
    if (!moveFocus) return;
    var next = index + 1 < length ? index + 1 : null;
    if (next) {
      focus(next);
    }
  }, [focus, length, moveFocus]);
  var handleResetPinInput = useCallback(function() {
    setValues(Array(length).fill(""));
    onChange === null || onChange === void 0 || onChange("");
    if (focusFirstInputOnReset) {
      focus(0);
      setFocusedIndex(0);
    }
  }, [length, onChange, focus, focusFirstInputOnReset]);
  var setValue = useCallback(function(value, index) {
    var nextValues = _toConsumableArray(values);
    nextValues[index] = value;
    setValues(nextValues);
    onChange === null || onChange === void 0 || onChange(nextValues.join(""));
    var isComplete = value !== "" && nextValues.length === length && nextValues.every(function(inputValue) {
      return inputValue != null && inputValue !== "";
    }) && index == length - 1;
    if (!isComplete) {
      setMoveFocus(true);
      focusNext(index);
    }
  }, [focusNext, length, onChange, values]);
  var handleInputChange = function handleInputChange2(event, inputFieldIndex) {
    var eventValue = event.currentTarget.value;
    var currentValue = values[inputFieldIndex];
    if (eventValue === "") {
      setValue("", inputFieldIndex);
      return;
    }
    if (eventValue.length > 1 && inputFieldIndex < length - 1) {
      if (validate(eventValue, type)) {
        var nextValue = [];
        if (currentValue == "") {
          nextValue = eventValue.split("").filter(function(_, j) {
            return inputFieldIndex + j < length;
          });
        } else if (event.currentTarget.selectionEnd === eventValue.length) {
          nextValue = eventValue.split("").filter(function(_, j) {
            return j > 0 && inputFieldIndex + j - 1 < length;
          });
        } else {
          nextValue = eventValue.split("").filter(function(_, j) {
            return j < eventValue.length - 1 && inputFieldIndex + j < length;
          });
        }
        setValues(function(values2) {
          return values2.map(function(v, j) {
            return j >= inputFieldIndex && j < inputFieldIndex + nextValue.length ? nextValue[j - inputFieldIndex] : v;
          });
        });
        focus(inputFieldIndex + nextValue.length < length ? inputFieldIndex + nextValue.length : length - 1);
        onChange === null || onChange === void 0 || onChange(nextValue.join(""));
      }
    } else {
      var _nextValue = eventValue;
      if ((currentValue === null || currentValue === void 0 ? void 0 : currentValue.length) > 0) {
        if (currentValue[0] === eventValue.charAt(0)) {
          _nextValue = eventValue.charAt(1);
        } else if (currentValue[0] === eventValue.charAt(1)) {
          _nextValue = eventValue.charAt(0);
        }
      }
      if (validate(_nextValue, type)) {
        setValue(_nextValue, inputFieldIndex);
      }
    }
  };
  var _onKeyDown = function onKeyDown(event, i) {
    if (event.key === "Backspace") {
      if (event.target.value === "") {
        if (i > 0) {
          var newIndex = i - 1;
          setValue("", newIndex);
          focus(newIndex);
          setMoveFocus(true);
        }
      } else {
        setMoveFocus(false);
      }
    } else if (event.key === "Escape") {
      var _inputRefs$i$current;
      (_inputRefs$i$current = inputRefs[i].current) === null || _inputRefs$i$current === void 0 || _inputRefs$i$current.blur();
      onBlur();
    } else if (event.key === "ArrowRight") {
      if (i < length - 1) {
        focus(i + 1);
      }
    } else if (event.key === "ArrowLeft") {
      if (i > 0) {
        focus(i - 1);
      }
    }
  };
  var _onFocus = function onFocus(e, i) {
    setFocusedIndex(i);
  };
  var _onSelect = function onSelect(e) {
    var target = e.target;
    setTimeout(function() {
      target.setSelectionRange(target.value.length, target.value.length);
    }, 0);
  };
  var onBlur = function onBlur2() {
    setFocusedIndex(-1);
  };
  var classNames = [];
  if (isFullWidth) {
    classNames.push("full-width");
  }
  return /* @__PURE__ */ React__default.createElement(Div, _extends({
    "data-pin-input-field": true,
    ref: pinInputFieldRef
  }, props, {
    classNames
  }), _toConsumableArray(Array(length)).map(function(_, i) {
    return /* @__PURE__ */ React__default.createElement(InputField, {
      key: i,
      ref: inputRefs[i],
      type: mask ? "password" : type === "number" ? "tel" : "text",
      inputMode: type === "number" ? "numeric" : "text",
      onChange: function onChange2(e) {
        return handleInputChange(e, i);
      },
      onKeyDown: function onKeyDown(e) {
        return _onKeyDown(e, i);
      },
      onFocus: function onFocus(e) {
        return _onFocus(e, i);
      },
      onSelect: function onSelect(e) {
        return _onSelect(e);
      },
      onBlur,
      placeholder: focusedIndex !== i ? "⦁" : void 0,
      autoComplete: isOTP ? "one-time-code" : "off",
      value: values[i] || "",
      autoFocus: autoFocus && i === 0,
      onCopy: function onCopy(e) {
        return pasteFromClipboard === "disabled" && e.preventDefault();
      },
      onPaste: function onPaste(e) {
        return pasteFromClipboard === "disabled" && e.preventDefault();
      }
    });
  }));
});
export {
  PinInputField
};
