"use client";
"use client;";
import React__default from "react";
import { RadioButton } from "./RadioButton.js";
import { Element } from "../../Element/Element.js";
import { BaseInputComponent } from "../BaseInputComponent/BaseInputComponent.js";
var _excluded = ["options", "defaultValue", "required"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var RadioGroupOptions = function RadioGroupOptions2(_ref) {
  var options = _ref.options;
  _ref.defaultValue;
  var required = _ref.required, props = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ React__default.createElement(Element, {
    as: "div",
    required
  }, options.map(function(option, index) {
    return /* @__PURE__ */ React__default.createElement(RadioButton, _extends({
      key: index
    }, props, option));
  }));
};
var RadioGroup = /* @__PURE__ */ React__default.forwardRef(function(props, ref) {
  return /* @__PURE__ */ React__default.createElement(BaseInputComponent, _extends({
    as: RadioGroupOptions,
    ref
  }, props));
});
export {
  RadioGroup
};
