"use client";
"use client;";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { Div } from "../../Element/Tags.js";
import { BaseInputComponent } from "../BaseInputComponent/BaseInputComponent.js";
import { InputLabel } from "../InputLabel/InputLabel.js";
import { Text } from "../../Typography/Text.js";
var _excluded = ["label", "value", "suffix"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Range = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var label = _ref.label, value = _ref.value, suffix = _ref.suffix, props = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ React__default.createElement(Element, {
    "data-range": true,
    ref
  }, label && /* @__PURE__ */ React__default.createElement(Div, {
    "data-range-meta": true
  }, /* @__PURE__ */ React__default.createElement(InputLabel, {
    className: "range-label",
    label,
    htmlFor: props.id
  }), /* @__PURE__ */ React__default.createElement(Text, {
    className: "range-value"
  }, value, suffix && suffix)), /* @__PURE__ */ React__default.createElement(BaseInputComponent, _extends({
    as: "input",
    type: "range",
    value
  }, props)));
});
export {
  Range
};
