"use client";
"use client;";
import React__default, { useRef, useImperativeHandle } from "react";
import { Element } from "../../Element/Element.js";
import { u as useClickOutside } from "../../../UseClickOutside-Cy7gG1w2.js";
var _excluded = ["collapsed", "closeOnClickOutside", "showMobileSidebar"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var SidebarWrapper = /* @__PURE__ */ React__default.forwardRef(function(_ref, forwardedRef) {
  var collapsed = _ref.collapsed, closeOnClickOutside = _ref.closeOnClickOutside, showMobileSidebar = _ref.showMobileSidebar, props = _objectWithoutProperties(_ref, _excluded);
  var internalRef = useRef(null);
  useImperativeHandle(forwardedRef, function() {
    return internalRef.current;
  });
  useClickOutside(internalRef, function() {
    if (typeof closeOnClickOutside === "function") {
      closeOnClickOutside();
    }
  });
  var classNames = [];
  if (collapsed) {
    classNames.push("collapsed");
  }
  if (showMobileSidebar) {
    classNames.push("show-sidebar");
  }
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "aside",
    "data-sidebar-wrapper": true,
    ref: internalRef,
    classNames
  }, props));
});
export {
  SidebarWrapper
};
