"use client";
"use client;";
import React__default from "react";
import { Element } from "../Element/Element.js";
var _excluded = ["weight", "size", "fontStyle", "align", "isSubtext"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Text = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var weight = _ref.weight, size = _ref.size, _ref$fontStyle = _ref.fontStyle, fontStyle = _ref$fontStyle === void 0 ? "sans-serif" : _ref$fontStyle, align = _ref.align, isSubtext = _ref.isSubtext, props = _objectWithoutProperties(_ref, _excluded);
  var classNames = [];
  if (weight) {
    classNames.push("weight-".concat(weight));
  }
  if (size) {
    classNames.push("text-".concat(size));
  }
  if (fontStyle) {
    classNames.push("font-".concat(fontStyle));
  }
  if (isSubtext) {
    classNames.push("sub-text");
  }
  if (align) {
    classNames.push("text-".concat(align));
  }
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "p",
    ref,
    classNames
  }, props));
});
export {
  Text
};
