"use client";
"use client;";
import React__default from "react";
var createClassName = function createClassName2(classNames) {
  return classNames.filter(function(item) {
    return !!item;
  }).join(" ");
};
var _excluded = ["as", "role", "ariaLabel", "tabIndex", "onKeyDown"], _excluded2 = ["classNames", "bgColor", "bgColour", "borderColor", "borderColour", "className", "columns", "fillColor", "fillColour", "gap", "hideOnDesktop", "hideOnMobile", "hideOnTabletLandscape", "hideOnTabletPortrait", "horizontalMargin", "horizontalPadding", "horizontallyCenterThis", "horizontallyCentreThis", "isFullHeight", "isFullWidth", "layoutAsFlexbox", "layoutAsGrid", "marginLeft", "marginBottom", "margin", "marginRight", "marginTop", "opacity", "paddingBottom", "paddingLeft", "padding", "paddingRight", "paddingTop", "pushItemsToEnds", "shadow", "shape", "showOnlyOnDesktop", "showOnlyOnMobile", "showOnlyOnTabletLandscape", "showOnlyOnTabletPortrait", "size", "strokeColor", "strokeColour", "textColor", "textColour", "verticalMargin", "verticalPadding", "verticallyCenterItems", "verticallyCentreItems", "weight"], _excluded3 = ["className", "classNames"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Element = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var _ref$as = _ref.as, Component = _ref$as === void 0 ? "div" : _ref$as, role = _ref.role, ariaLabel = _ref.ariaLabel, tabIndex = _ref.tabIndex, onKeyDown = _ref.onKeyDown, props = _objectWithoutProperties(_ref, _excluded);
  var _props$classNames = props.classNames, classNames = _props$classNames === void 0 ? [] : _props$classNames, bgColor = props.bgColor, bgColour = props.bgColour, borderColor = props.borderColor, borderColour = props.borderColour, className = props.className;
  props.columns;
  var fillColor = props.fillColor, fillColour = props.fillColour;
  props.gap;
  var hideOnDesktop = props.hideOnDesktop, hideOnMobile = props.hideOnMobile, hideOnTabletLandscape = props.hideOnTabletLandscape, hideOnTabletPortrait = props.hideOnTabletPortrait, horizontalMargin = props.horizontalMargin, horizontalPadding = props.horizontalPadding, horizontallyCenterThis = props.horizontallyCenterThis, horizontallyCentreThis = props.horizontallyCentreThis, isFullHeight = props.isFullHeight, isFullWidth = props.isFullWidth, layoutAsFlexbox = props.layoutAsFlexbox, layoutAsGrid = props.layoutAsGrid, marginLeft = props.marginLeft, marginBottom = props.marginBottom, margin = props.margin, marginRight = props.marginRight, marginTop = props.marginTop, opacity = props.opacity, paddingBottom = props.paddingBottom, paddingLeft = props.paddingLeft, padding = props.padding, paddingRight = props.paddingRight, paddingTop = props.paddingTop, pushItemsToEnds = props.pushItemsToEnds, shadow = props.shadow, shape = props.shape, showOnlyOnDesktop = props.showOnlyOnDesktop, showOnlyOnMobile = props.showOnlyOnMobile, showOnlyOnTabletLandscape = props.showOnlyOnTabletLandscape, showOnlyOnTabletPortrait = props.showOnlyOnTabletPortrait, size = props.size, strokeColor = props.strokeColor, strokeColour = props.strokeColour, textColor = props.textColor, textColour = props.textColour, verticalMargin = props.verticalMargin, verticalPadding = props.verticalPadding, verticallyCenterItems = props.verticallyCenterItems, verticallyCentreItems = props.verticallyCentreItems, weight = props.weight, minimalProps = _objectWithoutProperties(props, _excluded2);
  props.className;
  props.classNames;
  _objectWithoutProperties(props, _excluded3);
  return /* @__PURE__ */ React__default.createElement(Component, _extends({
    ref,
    role,
    "aria-label": ariaLabel,
    tabIndex,
    onKeyDown
  }, minimalProps, {
    className: createClassName([className, bgColor && "bg-".concat(bgColor), bgColour && "bg-".concat(bgColour), borderColor && "border-".concat(borderColor), borderColour && "border-".concat(borderColour), fillColor && "fill-".concat(fillColor), fillColour && "fill-".concat(fillColour), hideOnDesktop && "hide-on-desktop", hideOnMobile && "hide-on-mobile", hideOnTabletLandscape && "hide-on-tablet-landscape", hideOnTabletPortrait && "hide-on-tablet-portrait", horizontalMargin && "margin-right-".concat(horizontalMargin, " margin-left-").concat(horizontalMargin), horizontalPadding && "padding-right-".concat(horizontalPadding, " padding-left-").concat(horizontalPadding), horizontallyCenterThis && "horizontally-centre-this", horizontallyCentreThis && "horizontally-centre-this", isFullHeight && "full-height", isFullWidth && "full-width", layoutAsFlexbox && "layout-flexbox", layoutAsGrid && "layout-grid", marginLeft && "margin-left-".concat(marginLeft), marginBottom && "margin-bottom-".concat(marginBottom), margin && "margin-all-".concat(margin), marginRight && "margin-right-".concat(marginRight), marginTop && "margin-top-".concat(marginTop), opacity && "opacity-".concat(opacity), paddingBottom && "padding-bottom-".concat(paddingBottom), paddingLeft && "padding-left-".concat(paddingLeft), padding && "padding-all-".concat(padding), paddingRight && "padding-right-".concat(paddingRight), paddingTop && "padding-top-".concat(paddingTop), pushItemsToEnds && "push-to-ends", shadow && "shadow-".concat(shadow), shape && "shape-".concat(shape), showOnlyOnDesktop && "show-only-on-desktop", showOnlyOnMobile && "show-only-on-mobile", showOnlyOnTabletLandscape && "show-only-on-tablet-landscape", showOnlyOnTabletPortrait && "show-only-on-tablet-portrait", size && "size-".concat(size), strokeColor && "stroke-".concat(strokeColor), strokeColour && "stroke-".concat(strokeColour), textColor && "text-".concat(textColor), textColour && "text-".concat(textColour), verticalMargin && "margin-top-".concat(verticalMargin, " margin-bottom-").concat(verticalMargin), verticalPadding && "padding-top-".concat(verticalPadding, " padding-bottom-").concat(verticalPadding), verticallyCenterItems && "vertically-centre-items", verticallyCentreItems && "vertically-centre-items", weight && "weight-".concat(weight)].concat(classNames))
  }));
});
export {
  Element
};
