"use client";
"use client;";
import React__default from "react";
import { Element } from "./Element.js";
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
var createComponentWithElement = function createComponentWithElement2(tagName) {
  return /* @__PURE__ */ React__default.forwardRef(function(props, ref) {
    return /* @__PURE__ */ React__default.createElement(Element, _extends({
      as: tagName,
      ref
    }, props));
  });
};
var Article = createComponentWithElement("article");
var Aside = createComponentWithElement("aside");
var Body = createComponentWithElement("body");
var Div = createComponentWithElement("div");
var Footer = createComponentWithElement("footer");
var Header = createComponentWithElement("header");
var Main = createComponentWithElement("main");
var Nav = createComponentWithElement("nav");
var Section = createComponentWithElement("section");
var Span = createComponentWithElement("span");
export {
  Article,
  Aside,
  Body,
  Div,
  Footer,
  Header,
  Main,
  Nav,
  Section,
  Span
};
