"use client";
"use client;";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { BaseInputComponent } from "../BaseInputComponent/BaseInputComponent.js";
var _excluded = ["size"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Switch = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var _ref$size = _ref.size, size = _ref$size === void 0 ? "medium" : _ref$size, props = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ React__default.createElement(Element, {
    as: "div",
    "data-switch": true,
    ref,
    className: "size-".concat(size)
  }, /* @__PURE__ */ React__default.createElement(BaseInputComponent, _extends({
    as: "input",
    type: "checkbox"
  }, props)));
});
export {
  Switch
};
