"use client";
"use client;";
import React__default from "react";
import { Div } from "../../Element/Tags.js";
import { BaseInputComponent } from "../BaseInputComponent/BaseInputComponent.js";
var _excluded = ["options", "defaultValue", "value", "required"], _excluded2 = ["size"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var RadioTabGroupOptions = function RadioTabGroupOptions2(_ref) {
  var options = _ref.options, defaultValue = _ref.defaultValue, value = _ref.value, required = _ref.required, props = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ React__default.createElement(Div, {
    "data-radio-tab-group": true,
    name: props.name,
    required
  }, options.map(function(option) {
    return /* @__PURE__ */ React__default.createElement(React__default.Fragment, {
      key: option.id
    }, /* @__PURE__ */ React__default.createElement("input", _extends({
      type: "radio"
    }, props, option, {
      defaultChecked: defaultValue === option.value,
      checked: value === option.value
    })), /* @__PURE__ */ React__default.createElement("label", {
      htmlFor: option.id
    }, option.label));
  }));
};
var RadioTabGroup = /* @__PURE__ */ React__default.forwardRef(function(_ref2, ref) {
  var _ref2$size = _ref2.size, size = _ref2$size === void 0 ? "medium" : _ref2$size, props = _objectWithoutProperties(_ref2, _excluded2);
  var classNames = [];
  if (size) {
    classNames.push("size-".concat(size));
  }
  return /* @__PURE__ */ React__default.createElement(BaseInputComponent, _extends({
    as: RadioTabGroupOptions,
    ref,
    classNames,
    bgColour: props.bgColour
  }, props));
});
export {
  RadioTabGroup
};
