"use client";
"use client;";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { BaseInputComponent } from "../BaseInputComponent/BaseInputComponent.js";
import { Div } from "../../Element/Tags.js";
var _excluded = ["options", "className"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var SelectWithOptions = function SelectWithOptions2(_ref) {
  var options = _ref.options, className = _ref.className, props = _objectWithoutProperties(_ref, _excluded);
  var renderOption = function renderOption2(option) {
    return /* @__PURE__ */ React__default.createElement(Element, {
      as: "option",
      key: option.value,
      value: option.value,
      disabled: option.disabled
    }, option.label);
  };
  var renderOptGroup = function renderOptGroup2(group) {
    return /* @__PURE__ */ React__default.createElement(Element, {
      as: "optgroup",
      key: group.label,
      label: group.label
    }, group.options.map(renderOption));
  };
  return /* @__PURE__ */ React__default.createElement(Div, {
    "data-select": true,
    className,
    disabled: props.disabled
  }, /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "select"
  }, props), options.map(function(option) {
    return (
      // @ts-ignore
      "options" in option ? renderOptGroup(option) : renderOption(option)
    );
  })));
};
var Select = /* @__PURE__ */ React__default.forwardRef(function(props, ref) {
  return /* @__PURE__ */ React__default.createElement(BaseInputComponent, _extends({
    as: SelectWithOptions,
    ref
  }, props));
});
export {
  Select
};
